#include "windows.h"
#include "stdio.h"
#include "wchar.h"

extern "C" {
#include "powrprof.h"
}

#include <string>

bool verbose = 0;
int found = -1;
UINT currentscheme = -1;

BOOLEAN CALLBACK
enumcb(UINT uiIndex,      // power scheme index
       DWORD dwName,      // size of the sName string, in bytes
       LPTSTR sName,      // name of the power scheme
       DWORD dwDesc,      // size of the sDesc string, in bytes
       LPTSTR sDesc,      // description string
       PPOWER_POLICY pp,  // receives the power policy
       LPARAM lParam      // user-defined value
      )
{
    char c = ' ';
    if (currentscheme == -1)
	GetActivePwrScheme(&currentscheme);
    if (currentscheme == uiIndex)
	c = '*';

    printf("%c%d: %ws", c, uiIndex, sName);

    if (verbose)
	printf(" (%ws)", sDesc);

    printf("\n");
    fflush(stdout);

    return 1;
}

int
main(int argc, char *argv[])
{
    if (argc > 1) {
	if (!strcmp(argv[1], "-v")) {
	    verbose = 1;
	    argc--;
	}
    }

    if (argc == 1)
	EnumPwrSchemes(enumcb, NULL);
    else
	SetActivePwrScheme(atoi(argv[1]), NULL, NULL);


    return 0;
}
